package com.zipcoder.payment;

public class Check implements Payment {
    private Long id;
    private String payerName;
    private String routingNumber;
    private String accountNumber;

    public Check(){
        this.id=id;
        this.payerName = payerName;
        this.accountNumber = accountNumber;
        this.routingNumber=routingNumber;
    }


    public Check(Long id, String payerName,String routingNumber, String accountNumber) {
        this.payerName = payerName;
        this.accountNumber = accountNumber;
        this.id=id;
        this.routingNumber=routingNumber;
    }

    public void setId(Long id) {
        this.id = id;
    }
    @Override
    public Long getId() {
        return  id;
    }


    @Override
    public String getPayerName() {
        return payerName;
    }

    @Override
    public String getShortDescription() {
        return  "Check " + getPayerName() + " ***"+ getLast4Digit();
    }


    public void setPayerName(String payerName) {
        this.payerName = payerName;
    }

    public String getRoutingNumber() {
        return routingNumber;
    }

    public void setRoutingNumber(String routingNumber) {
        this.routingNumber = routingNumber;
    }

    public String getAccountNumber() {
        return accountNumber;
    }

    public void setAccountNumber(String accountNumber) {
        this.accountNumber = accountNumber;
    }



    public String getLast4Digit() {
        String str="";
        if (accountNumber.length() == 4) {
            str= accountNumber;
        } else if (accountNumber.length() > 4) {
            str= accountNumber.substring(accountNumber.length() - 4);

        }
        return str;
    }

    @Override
    public int compareTo(Payment other) {

        return this.getShortDescription().compareTo(other.getShortDescription());
     }
}
